; 
    include \masm32\include\masm32rt.inc

    IDC_WS_BORDER           EQU 1000
    IDC_WS_CAPTION          EQU 1001
    IDC_WS_DISABLED         EQU 1002
    IDC_WS_DLGFRAME         EQU 1003
    IDC_WS_HSCROLL          EQU 1004
    IDC_WS_ICONIC           EQU 1005
    IDC_WS_MAXIMIZE         EQU 1006
    IDC_WS_MAXIMIZEBOX      EQU 1007
    IDC_WS_MINIMIZE         EQU 1008
    IDC_WS_MINIMIZEBOX      EQU 1009
    IDC_WS_OVERLAPPED       EQU 1010
    IDC_WS_OVERLAPPEDWINDOW EQU 1011
    IDC_WS_POPUP            EQU 1012
    IDC_WS_POPUPWINDOW      EQU 1013
    IDC_WS_SIZEBOX          EQU 1014
    IDC_WS_SYSMENU          EQU 1015
    IDC_WS_THICKFRAME       EQU 1016
    IDC_WS_TILED            EQU 1017
    IDC_WS_TILEDWINDOW      EQU 1018
    IDC_WS_VISIBLE          EQU 1019
    IDC_WS_VSCROLL          EQU 1020

    IDC_CREATEWIN           EQU 1021
    IDC_CLEARALL            EQU 1022

    IDC_CHILD               EQU 1023 

    DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    CreateWindow PROTO :DWORD

    PushButton PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

    .data
        hInstance dd 0
        xCoord    dd 270 
        yCoord    dd -35
        fQuitNow  dd 0
        className db "wsdemo_class",0
    .code
; 
start: 

      mov hInstance, rv(GetModuleHandle,NULL)
      call Main
      invoke ExitProcess, eax

; 

Main proc

    Dialog "WSDEMO",\
           "MS Sans Serif",8,\
            WS_OVERLAPPED or WS_SYSMENU,\
            23,\                           ; number of controls
            5,5,120,270,\
            2048                           ; buffer size 

    X = 12
    Y = 4
    W = 100
    H = 10
    YI = 11
    DlgCheck "WS_BORDER",WS_TABSTOP,X,Y,W,H,IDC_WS_BORDER
    Y = Y + YI
    DlgCheck "WS_CAPTION",WS_TABSTOP,X,Y,W,H,IDC_WS_CAPTION
    Y = Y + YI
    DlgCheck "WS_DISABLED",WS_TABSTOP,X,Y,W,H,IDC_WS_DISABLED
    Y = Y + YI
    DlgCheck "WS_DLGFRAME",WS_TABSTOP,X,Y,W,H,IDC_WS_DLGFRAME
    Y = Y + YI
    DlgCheck "WS_HSCROLL",WS_TABSTOP,X,Y,W,H,IDC_WS_HSCROLL
    Y = Y + YI
    DlgCheck "WS_ICONIC",WS_TABSTOP,X,Y,W,H,IDC_WS_ICONIC
    Y = Y + YI
    DlgCheck "WS_MAXIMIZE",WS_TABSTOP,X,Y,W,H,IDC_WS_MAXIMIZE
    Y = Y + YI
    DlgCheck "WS_MAXIMIZEBOX",WS_TABSTOP,X,Y,W,H,IDC_WS_MAXIMIZEBOX
    Y = Y + YI
    DlgCheck "WS_MINIMIZE",WS_TABSTOP,X,Y,W,H,IDC_WS_MINIMIZE
    Y = Y + YI
    DlgCheck "WS_MINIMIZEBOX",WS_TABSTOP,X,Y,W,H,IDC_WS_MINIMIZEBOX
    Y = Y + YI
    DlgCheck "WS_OVERLAPPED",WS_TABSTOP,X,Y,W,H,IDC_WS_OVERLAPPED
    Y = Y + YI
    DlgCheck "WS_OVERLAPPEDWINDOW",WS_TABSTOP,X,Y,W,H,IDC_WS_OVERLAPPEDWINDOW
    Y = Y + YI
    DlgCheck "WS_POPUP",WS_TABSTOP,X,Y,W,H,IDC_WS_POPUP
    Y = Y + YI
    DlgCheck "WS_POPUPWINDOW",WS_TABSTOP,X,Y,W,H,IDC_WS_POPUPWINDOW
    Y = Y + YI
    DlgCheck "WS_SIZEBOX",WS_TABSTOP,X,Y,W,H,IDC_WS_SIZEBOX
    Y = Y + YI
    DlgCheck "WS_SYSMENU",WS_TABSTOP,X,Y,W,H,IDC_WS_SYSMENU
    Y = Y + YI
    DlgCheck "WS_THICKFRAME",WS_TABSTOP,X,Y,W,H,IDC_WS_THICKFRAME
    Y = Y + YI
    DlgCheck "WS_TILED",WS_TABSTOP,X,Y,W,H,IDC_WS_TILED
    Y = Y + YI
    DlgCheck "WS_TILEDWINDOW",WS_TABSTOP,X,Y,W,H,IDC_WS_TILEDWINDOW
    Y = Y + YI
    DlgCheck "WS_VISIBLE",WS_TABSTOP,X,Y,W,H,IDC_WS_VISIBLE
    Y = Y + YI    
    DlgCheck "WS_VSCROLL",WS_TABSTOP,X,Y,W,H,IDC_WS_VSCROLL

    DlgButton "Clear All",WS_TABSTOP,5,238,50,10,IDC_CLEARALL 
    DlgButton "Create Window",WS_TABSTOP,60,238,50,10,IDC_CREATEWIN

    CallModalDialog hInstance,0,DlgProc,NULL    

    ret
Main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL ws:DWORD

    .If uMsg == WM_INITDIALOG

    .ElseIf uMsg == WM_COMMAND

      Switch wParam

      Case IDC_CREATEWIN

        mov   ws, 0
        invoke SendDlgItemMessage,hWin,IDC_WS_BORDER,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_BORDER
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_CAPTION,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_CAPTION
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_DISABLED,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_DISABLED
        .EndIf        
        invoke SendDlgItemMessage,hWin,IDC_WS_DLGFRAME,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_DLGFRAME
        .EndIf        
        invoke SendDlgItemMessage,hWin,IDC_WS_HSCROLL,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_HSCROLL
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_ICONIC,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_ICONIC
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_MAXIMIZE,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_MAXIMIZE
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_MAXIMIZEBOX,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_MAXIMIZEBOX
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_MINIMIZE,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_MINIMIZE
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_MINIMIZEBOX,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_MINIMIZEBOX
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_OVERLAPPED,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_OVERLAPPED
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_OVERLAPPEDWINDOW,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_OVERLAPPEDWINDOW
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_POPUP,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_POPUP
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_POPUPWINDOW,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_POPUPWINDOW
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_SIZEBOX,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_SIZEBOX
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_SYSMENU,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_SYSMENU
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_THICKFRAME,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_THICKFRAME
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_TILED,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_TILED
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_TILEDWINDOW,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_TILEDWINDOW
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_VISIBLE,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_VISIBLE
        .EndIf
        invoke SendDlgItemMessage,hWin,IDC_WS_VSCROLL,BM_GETCHECK,0,0
        .If eax == BST_CHECKED
          or  ws, WS_VSCROLL
        .EndIf

        invoke CreateWindow, ws

      Case IDC_CLEARALL

        For idc, <1000,1001,1002,1003,1004,1005,1006,1007,1008,1009,1010>
          invoke SendDlgItemMessage, hWin, idc, BM_SETCHECK, 0, 0
        Endm

        For idc, <1011,1012,1013,1014,1015,1016,1017,1018,1019,1020>
          invoke SendDlgItemMessage, hWin, idc, BM_SETCHECK, 0, 0
        Endm

      EndSw      

    .ElseIf uMsg == WM_CLOSE

       inc    fQuitNow
       invoke EndDialog, hWin, 0

    .EndIf

    xor eax, eax
    ret

DlgProc endp

; 
CreateWindow proc ws:DWORD

    LOCAL hWnd:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG

    add   xCoord, 20
    add   yCoord, 35

    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInstance
    invoke GetStockObject, WHITE_BRUSH
    mov   wc.hbrBackground, eax
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         NULL
    mov   wc.hCursor,       NULL
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("WSDEMO"),
                            ws,
                            xCoord,yCoord,200,150,
                            NULL, NULL,
                            hInstance, NULL
    mov   hWnd, eax

    invoke PushButton,chr$("button"),hWnd,1,1,100,25,IDC_CHILD
    
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd

  msgLoop:

    invoke GetMessage, ADDR msg, NULL, 0, 0
    .If (eax != 0 && fQuitNow != 0)
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp   msgLoop
    .EndIf

    return msg.wParam

CreateWindow endp

; 

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    
    .If (uMsg == WM_DESTROY)
        invoke PostQuitMessage, NULL
        return 0
    .EndIf
    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret

WndProc endp

; 

PushButton proc lpText:DWORD,hParent:DWORD,
                a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

    szText btnClass,"BUTTON"

    invoke CreateWindowEx,0,
            ADDR btnClass,lpText,
            WS_CHILD or WS_VISIBLE,
            a,b,wd,ht,hParent,ID,
            hInstance,NULL

    ret

PushButton endp

; 

end start
